Loading...
Searching...
No Matches
casacore::FITSQualityMask Class Reference
images package (libcasa_images) » Images_module

More...

`#include <FITSQualityMask.h>`

## Public Member Functions

| FITSQualityMask (FITSImage *fitsData, FITSErrorImage *fitsError)
| The pointers are not cloned, just copied.
| FITSQualityMask (const FITSQualityMask &other)
| Copy constructor (reference semantics).
virtual | ~FITSQualityMask ()
| Destructor.
FITSQualityMask & | operator= (const FITSQualityMask &other)
| The assignment operator with reference semantics.
virtual Lattice< Bool > * | clone () const
| Make a copy of the object (reference semantics).
virtual Bool | isWritable () const
| Is the FITSMask writable?
IPosition | shape () const
| Return the shape of the Lattice including all degenerate axes (ie.
virtual Bool | doGetSlice (Array< Bool > &buffer, const Slicer &section)
| Do the actual getting of an array of values.
virtual void | doPutSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| Do the actual getting of an array of values.
virtual void | setFilterZero (Bool filterZero)
| Set the switch for filtering 0.0.
Public Member Functions inherited from casacore::Lattice< Bool >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
Bool | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual Bool | getAt (const IPosition &where) const
virtual void | putAt (const Bool &value, const IPosition &where)
| Put the value of a single element.
Bool | get (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | put (const Array< Bool > &sourceBuffer)
virtual void | set (const Bool &value)
| Set all elements in the Lattice to the given value.
virtual void | apply (Bool(*function)(Bool))
| Replace every element, x, of the Lattice with the result of f(x).
void | operator+= (const Lattice< Bool > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< Bool > &other)
void | operator*= (const Lattice< Bool > &other)
void | operator/= (const Lattice< Bool > &other)
virtual void | copyData (const Lattice< Bool > &from)
| Copy the data from the given lattice to this one.
virtual void | copyDataTo (Lattice< Bool > &to) const
| Copy the data from this lattice to the given lattice.
virtual uInt | advisedMaxPixels () const
| This function returns the advised maximum number of pixels to include in the cursor of an iterator.
virtual LatticeIterInterface< Bool > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| These functions are used by the LatticeIterator class to generate an iterator of the correct type for a specified Lattice.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| It is strongly recommended to use class LatticeLocker to handle lattice locking.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
virtual String | name (Bool stripPath=False) const
| Return the name of the current Lattice object.
virtual uInt | ndim () const
| Return the number of axes in this Lattice.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
virtual LELCoordinates | lelCoordinates () const
| Return the coordinates of the lattice.
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual Bool | ok () const
| Check class internals - used for debugging.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| The function (in the derived classes) doing the actual work.
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Private Member Functions

| FITSQualityMask ()
Bool | filterNaN (bool *pMask, const float *pData, const uInt nelems)
| Mask out ONLY NaN's.
Bool | filterZeroNaN (Bool *pMask, const Float *pData, const uInt nelems)
| Mask out NaN's and values 0.0.

## Private Attributes

FITSImage * | itsFitsData
FITSErrorImage * | itsFitsError
Array< Float > | itsBuffer
Bool | itsFilterZero

## Additional Inherited Members

Protected Member Functions inherited from casacore::Lattice< Bool >
void | handleMathTo (Lattice< Bool > &, int) const
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< Bool > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
Lattice< Bool > & | operator= (const Lattice< Bool > &)
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Detailed Description

Provides an on-the-fly mask for FITS quality images

### Intended use:

Public interface

### Prerequisite

- Lattice
- FITSQualityImage

### Etymology

This class provides a pixel mask for the FITSQualityImage class.

### Synopsis

Masked values are indicated in FITS images via magic value blanking. This class provides an on-the-fly mask. The doGetSlice function reads the data values and returns an Array<Bool> which is True (good) or False (bad - blanked)

Because FITSMask inherits from Lattice<Bool> it can be used as the private pixel mask data member for FITSQualityImage returned by the MaskedLattice::pixelMask() functions

The FITSQualityMask object is constructed from the FITSImage objects of the data and the error extension. These must be the same one that the FITSQUalityImage object constructs internally. They shared by both FITSImage and FITSMask.

### Example

### Motivation

FITSQualityImage provides access to FITS images with a data and and error extension. It needed an efficient way to handle the pixel mask other than iterating all the way through the image first to set a mask.

Definition at line 94 of file FITSQualityMask.h.

## Constructor & Destructor Documentation

## FITSQualityMask() [1/3]

casacore::FITSQualityMask::FITSQualityMask | ( | FITSImage * | fitsData,
|  | FITSErrorImage * | fitsError )

The pointers are not cloned, just copied.

Referenced by FITSQualityMask(), and operator=().

## FITSQualityMask() [2/3]

casacore::FITSQualityMask::FITSQualityMask | ( | const FITSQualityMask & | other | ) |

Copy constructor (reference semantics).

References FITSQualityMask().

## ~FITSQualityMask()

virtual casacore::FITSQualityMask::~FITSQualityMask | ( |  | ) |

virtual

Destructor.

## FITSQualityMask() [3/3]

casacore::FITSQualityMask::FITSQualityMask | ( |  | ) |

private

## Member Function Documentation

## clone()

virtual Lattice< Bool > * casacore::FITSQualityMask::clone | ( |  | ) | const

virtual

Make a copy of the object (reference semantics).

Implements casacore::Lattice< Bool >.

References casacore::Lattice< Bool >::Lattice().

## doGetSlice()

virtual Bool casacore::FITSQualityMask::doGetSlice | ( | Array< Bool > & | buffer,
|  | const Slicer & | section )

virtual

Do the actual getting of an array of values.

Implements casacore::Lattice< Bool >.

## doPutSlice()

virtual void casacore::FITSQualityMask::doPutSlice | ( | const Array< Bool > & | sourceBuffer,
|  | const IPosition & | where,
|  | const IPosition & | stride )

virtual

Do the actual getting of an array of values.

Throws an exception.

Implements casacore::Lattice< Bool >.

## filterNaN()

Bool casacore::FITSQualityMask::filterNaN | ( | bool * | pMask,
|  | const float * | pData,
|  | const uInt | nelems )

private

Mask out ONLY NaN's.

## filterZeroNaN()

Bool casacore::FITSQualityMask::filterZeroNaN | ( | Bool * | pMask,
|  | const Float * | pData,
|  | const uInt | nelems )

private

Mask out NaN's and values 0.0.

## isWritable()

virtual Bool casacore::FITSQualityMask::isWritable | ( |  | ) | const

virtual

Is the FITSMask writable?

Returns False. Although it is not hard to implement writing of the mask, data values would be lost because of magic blanking.

Reimplemented from casacore::LatticeBase.

## operator=()

FITSQualityMask & casacore::FITSQualityMask::operator= | ( | const FITSQualityMask & | other | ) |

The assignment operator with reference semantics.

References FITSQualityMask().

## setFilterZero()

virtual void casacore::FITSQualityMask::setFilterZero | ( | Bool | filterZero | ) |

virtual

Set the switch for filtering 0.0.

## shape()

IPosition casacore::FITSQualityMask::shape | ( |  | ) | const

virtual

Return the shape of the Lattice including all degenerate axes (ie.

axes with a length of one)

Implements casacore::LatticeBase.

## Member Data Documentation

## itsBuffer

Array<Float> casacore::FITSQualityMask::itsBuffer

private

Definition at line 145 of file FITSQualityMask.h.

## itsFilterZero

Bool casacore::FITSQualityMask::itsFilterZero

private

Definition at line 146 of file FITSQualityMask.h.

## itsFitsData

FITSImage* casacore::FITSQualityMask::itsFitsData

private

Definition at line 143 of file FITSQualityMask.h.

## itsFitsError

FITSErrorImage* casacore::FITSQualityMask::itsFitsError

private

Definition at line 144 of file FITSQualityMask.h.

The documentation for this class was generated from the following file:

- images/Images/FITSQualityMask.h